# ASCII.pm - Character set definitions for a bare 7-bit ASCII terminal.

# Copyright (c)2000-2013, Chris Pressey, Cat's Eye Technologies.
# All rights reserved.
# Distributed under a BSD-style license; see the file LICENSE for more info.

%sc =
(
  'nwbox'  => '+',
  'nbox'   => '-',
  'nebox'  => '+',
  'wbox'   => '|',
  'ebox'   => '|',
  'swbox'  => '+',
  'sbox'   => '-',
  'sebox'  => '+',

  'person' => '@',

  'brick'  => '#',
  'hut'    => 'A',
  'tree'   => 'T',
  'water'  => '~',
  'door'   => '/',
  'closed' => '+',
  'stair'  => '>',   # todo: stair images both up and down
  'floor'  => '.',
  'dark'   => ' ',
  'hole'   => 'o',

  'hill'   => '~',
  'mountain'=> '^',
  'marsh'  => '_',

  'cloak'  => ']',
  'halter' => ']',
  'jacket' => ']',
  'leggings' => ']',
  'helm'   => ']',
  'gloves' => ']',
  'clothing' => ']',
  'boots'  => ']',
  'sleeves' => ']',
  'necklace' => ']',
  'bracelet' => ']',
  'belt' => ']',
  'ring' => '=',

  'tiny'   => ",",
  'rock'   => '*',
  'boulder'=> 'O',
  'ash'    => ',',
  'crystal'=> '*',

  'food'   => '%',
  'fruit'  => '%',
  'vegetable' => '%',
  'fungus' => '%',
  'root'   => '%',
  'grass'  => '"',
  'stalk'  => '"',
  'web'    => '|',

  'gas'    => '&',
  'gate'   => '+',

  'bottle' => '!',
  'coin'   => '$',

  'circle' => '0',

  'sword'  => '(',
  'stick'  => '(',
  'mace'   => '(',
  'scythe' => '(',
  'arrow'  => '/',
  'bow'    => ')',
  'crossbow'=> '}',

  'scroll' => '?',
  'instrument' => '[',

  'carcass'=> '%',

  'ursine' => 'B',
  'spider' => 'x',
  'serpent'=> 'S',
  'worm'   => 's',

  'feline' => 'c',
  'canine' => 'd',
  'primate'=> 'M',
  'bovine' => 'u',
  'porcine'=> 'p',

  'dwark'  => 'k',
  'grue'   => 'G',
  'grumchik'=>'g',
  'traiple'=> 't',

  'nymph'  => 'N',
  'dryad'  => 'D',
  'fairy'  => 'f',

  'skeleton'=>'z',
  'zombie'  =>'z',

  'hag'    => 'h',
  'gator'  => 'y',
  'bird'   => 'v',

  'honeycomb' => '#',
  'tunnel'    => '.',
  'jelly'     => '%',
  'bee'       => 'b',
  'grasshopper' => 'i',
);

1;
